#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;

struct road
{
    int v, w;
    bool hard;
};

int cmp(const void* a, const void* b)
{
    if(*((int*)a)>*((int*)b)) return 1;
    if(*((int*)a)==*((int*)b)) return 0;
    if(*((int*)a)<*((int*)b)) return -1;
}

vector<int> search_easy(int start, vector<pair<road, bool> > r)
{
    vector<int> con_easy;
    con_easy.push_back(start);
    vector<int> temp;

    for(int j = 0; j<r.size(); ++j)
    {
        if(con_easy==temp) break;
        temp=con_easy;
        for(int i = 0; i<r.size(); ++i)
        {
            if(r[i].first.hard || r[i].second) continue;
            if(r[i].first.v==start)
            {
                for(int k = 0; k<r.size(); ++k)
                {
                    if(r[k].first.v==start
                       || r[k].first.w==start) r[k].second=true;
                }
                start=r[i].first.w;
                r[i].second=true;
                con_easy.push_back(start);
            }
            else if(r[i].first.w==start)
            {
                for(int k = 0; k<r.size(); ++k)
                {
                    if(r[k].first.v==start
                       || r[k].first.w==start) r[k].second=true;
                }
                start=r[i].first.v;
                r[i].second=true;
                con_easy.push_back(start);
            }
        }


    }
    return con_easy;
}

int main()
{
    int n, m, b=0;
    int num_hard=0;
    cin>>n>>m;
    int a[n];
    for(int i = 0; i<n; ++i)
    {
        a[i]=i+1;
    }
    vector<road> roads;
    vector<pair<road, bool> > in;
    vector<int> out, diff;
    road r;

    for(int i = 0; i<m; ++i)
    {
        cin>>r.v>>r.w>>r.hard;
        roads.push_back(r);
    }

    for(int i = 0; i<roads.size(); ++i)
    {
        in.push_back(make_pair(roads[i], false));
    }

    out=search_easy(1, in);

    qsort(out.data(), out.size(), sizeof(int), cmp);

    for(int i = 0; i<n; ++i)
    {
        if(a[i]!=out[i-b])
        {
            diff.push_back(a[i]);
            ++b;
        }
    }

    cout<<diff.size();
}
