#include<iostream>
#include<tuple>
#include<vector>
#include<algorithm>
using namespace std;
const int MAX_N=1e5+4;
int n,m;
vector<tuple<int,int,int> >edges;
int sz[MAX_N];
int parent[MAX_N];
int Find(int u)
{
    if(parent[u]==u)return u;
    return parent[u]=Find(parent[u]);
}
void Merge(int u,int v)
{
    int urt=Find(u);
    int vrt=Find(v);

    if(sz[urt]>sz[vrt])swap(urt,vrt);

    sz[vrt]+=sz[urt];
    parent[urt]=vrt;
}
int main ()
{
    cin>>n>>m;
    int u,v,c;
    int ans=0;
    for(int i=1;i<=n;i++)
    {
        parent[i]=i;
        sz[i]=1;
    }
    for(int i=1;i<=m;i++)
    {
        cin>>u>>v>>c;
        edges.push_back({c,u,v});
    }
    sort(edges.begin(),edges.end());


    for(auto [cost,u,v]:edges)
    {
        if(Find(u)!=Find(v))
        {
            Merge(u,v);
            ans+=cost;
        }
    }

    cout<<ans<<"\n";




    return 0;
}

