#include <bits/stdc++.h>
#define endl '\n'

using namespace std;

const int MAXN = 50005;

int visited = 0, ans, V, E, color = 1;
int used[MAXN];
bool useful[MAXN];

struct Edge
{
    int from, to;
    Edge(){}
    Edge(int from, int to)
        :from(from), to(to){}

};

vector <int> easy[MAXN];
vector <int> hard[MAXN];
vector <Edge> edges;

void dfs1(int curr, int color)
{
    used[curr] = color;

    if (color == 1)
        visited++;

    for (int i:easy[curr])
    {
        if (used[i] == 0)
        {
           dfs1(i, color);
        }
    }

}

void dfs2(int curr)
{
    if (visited == V)
        return;

    used[curr] = true;

    for (int i:hard[curr])
    {
        if (!used[curr] && visited < V)
        {
            ans++;
            dfs2(i);
        }
    }
}

int main()
{
    ios::sync_with_stdio(false);
    cin.tie(0); cout.tie(0);

    cin >> V >> E;

    for (int i = 0; i < E; i++)
    {
        int u, v, type;
        cin >> u >> v >> type;

        if (type == 0)
        {
            easy[u].push_back(v);
            easy[v].push_back(u);
        }

        else
        {
            edges.emplace_back(u, v);
        }
    }

    for (int i = 1; i <= V; i++)
    {
        if (used[i] == 0)
        {
            dfs1(i, color);
            color++;
        }
    }

   /* for (Edge &e:edges)
    {
        if (used[e.from] == used[e.to])
            continue;

        hard[e.from].push_back(e.to);
        hard[e.to].push_back(e.from);

        if (used[e.from] == 1)
            useful[e.from] = true;

        if (used[e.to] == 1)
            useful[e.to] = true;
    }*/

    cout << color-2 << endl;

    return 0;
}
