#include <bits/stdc++.h>
#define endl '\n'

using namespace std;
typedef long long ll;

void speed()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);
}

const int maxn = 310;
int n, m, a[maxn][maxn], b[maxn][maxn], dp[maxn][maxn];
ll ans;

void input()
{
    cin >> n >> m;
    ///n = m = 300;
    for (int i = 1; i <= n; i ++)
        for (int j = 1; j <= m; j ++)
        {
            ///a[i][j] = rand() % (int)(1e4);
            cin >> a[i][j];
        }
}

void set_bits(int bit)
{
    for (int i = 1; i <= n; i ++)
        for (int j = 1; j <= m; j ++)
            if ((a[i][j] & (1 << bit)))
                b[i][j] = 1;
            else
                b[i][j] = 0;
}

void calculate_state()
{
    for (int i = 1; i <= n; i ++)
        for (int j = 1; j <= m; j ++)
        {
            dp[i][j] = (((dp[i - 1][j] ^
                          dp[i][j - 1]) ^
                         dp[i - 1][j - 1]) ^
                        b[i][j]);
        }

}

int get_xor(int x1, int y1, int x2, int y2)
{
    return (dp[x2][y2] ^
             dp[x2][y1 - 1]);
}

int pref[maxn][maxn][maxn][2];
void calculate_prefix()
{
    for (int j1 = 1; j1 <= m; j1 ++)
    {
        for (int j2 = j1; j2 <= m; j2 ++)
        {
            pref[j1][j2][0][0] = 1;
            for (int i = 1; i <= n; i ++)
            {
                pref[j1][j2][i][0] = pref[j1][j2][i - 1][0];
                pref[j1][j2][i][1] = pref[j1][j2][i - 1][1];
                pref[j1][j2][i][get_xor(1, j1, i, j2)] ++;
            }
        }
    }
}

int get_answer()
{

    int cnt = 0;
    for (int j1 = 1; j1 <= m; j1 ++)
        for (int j2 = j1; j2 <= m; j2 ++)
            for (int i = 1; i <= n; i ++)
            {
                int cur_xor = (get_xor(1, j1, i, j2) ^ 1);
                cnt = cnt + pref[j1][j2][i - 1][cur_xor];
                ///cout << get_xor(1, j1, i , j2) << endl;
                ///cout << i << " : " << j1 << " : " << j2 << " : " << pref[j1][j2][i][0] << " : " << pref[j1][j2][i][1] << " " << " " << cur_xor << " " << cnt << endl;
            }
            ///exit(0);

    return cnt;
}
void solve_for_bit(int bit)
{
    set_bits(bit);
    calculate_state();
    calculate_prefix();
    int cnt = get_answer();
    ans = ans + (ll)(cnt) * (ll)(1 << bit);
}

void split_bits()
{
    for (int bit = 0; bit <= 14; bit ++)
        solve_for_bit(bit);
}

void solve()
{
    input();
    split_bits();
    cout << ans << endl;
}

int main()
{
    speed();
    solve();
    return 0;
}

/**
3 3
1 1 0
0 1 0
0 0 0
*/
