#include <bits/stdc++.h>
#define endl '\n'

using namespace std;
typedef long long ll;

void speed()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);
}

const int maxn = 2e5 + 10;

struct edge
{
    int v, u, c;

    bool operator < (const edge &e)const
    {
        return c < e.c;
    }
}e[maxn];

int n, m, par[maxn], rnk[maxn];

int find_leader(int v)
{
    if (v == par[v])
        return v;

    return (par[v] = find_leader(par[v]));
}


bool unite(int v, int u)
{
    v = find_leader(v);
    u = find_leader(u);
    if (v == u)
        return false;

    if (rnk[v] < rnk[u])
        swap(v, u);
    par[u] = v;
    rnk[v] += rnk[u];
    return true;
}

void solve()
{
    cin >> n >> m;
    for (int i = 1; i <= m; i ++)
    {
        cin >> e[i].v >> e[i].u >> e[i].c;
    }

    sort(e + 1, e + m + 1);

    for (int i = 1; i <= n; i ++)
        par[i] = i, rnk[i] = 1;

        int ans = 0;
        for (int i = 1;  i <= m; i ++)
        {
            if (unite(e[i].v, e[i].u))
                ans += e[i].c;
        }

        cout << ans << endl;
}

int main()
{
    speed();
    solve();
    return 0;
}

/**
9 12
1 2 0
2 3 0
4 5 1
5 6 1
4 8 0
8 9 0
1 4 0
4 7 0
2 5 1
5 8 1
3 6 0
6 9 0
*/
