#include <bits/stdc++.h>
#define endl '\n'
using namespace std;
const int MAXN = 50005;
void speed()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);
}
int n, m;
vector < pair < int, int > > light, heavy;
void read()
{
    cin >> n >> m;
    int x, y, d;
    for (int i = 1; i <= m; ++ i)
    {
        cin >> x >> y >> d;
        if(d)heavy.push_back(make_pair(x, y));
        else light.push_back(make_pair(x, y));
    }
}

int p[MAXN], r[MAXN];
void init_dsu()
{
    for (int i = 1; i <= n; ++ i)
    {
        p[i] = i;
        r[i] = 1;
    }
}

int find_leader(int i)
{
    if(p[i] == i)return i;
    return (p[i] = find_leader(p[i]));
}

bool is_connected(int i, int j)
{
    return (find_leader(i) == find_leader(j));
}

void dsu(int i, int j)
{
    i = find_leader(i);
    j = find_leader(j);
    if(i == j)return;
    if(r[i] < r[j])swap(i, j);
    p[j] = i;
    r[i] += r[j];
}
int main()
{
    speed();

    read();
    init_dsu();
    int cnt = n-1, x, y;
    for (int i = 0; i < light.size() && cnt; ++ i)
    {
        x = light[i].first;
        y = light[i].second;
        if(!is_connected(x, y))
        {
            cnt --;
            dsu(x, y);
        }
    }
    int ans = 0;
    for (int i = 0; i < heavy.size() && cnt; ++ i)
    {
        x = heavy[i].first;
        y = heavy[i].second;
        if(!is_connected(x, y))
        {
            cnt --;
            ans ++;
            dsu(x, y);
        }
    }
    cout << ans << endl;
   return 0;
}
/**
9 12
1 2 0
2 3 0
4 5 1
5 6 1
4 8 0
8 9 0
1 4 0
4 7 0
2 5 1
5 8 1
3 6 0
6 9 0

9 10
1 2 0
1 4 0
2 3 1
3 4 1
3 5 0
4 5 1
2 7 1
2 9 0
7 9 0
7 8 1
*/
