#include <bits/stdc++.h>

typedef long long ll;
typedef long double ld;

const int MAX_N = 1e5 + 42;
const int INF = 1e9;
const int mon = 1e9+ 7;

std::vector< std::pair<int, std::pair<int, int>> > e;

int par[MAX_N];
int size[MAX_N];

int get( int a ){ return par[a] = ( a == par[a] ? a : get(par[a]) ); }

void uni( int a, int b ){
    a = get(a);
    b = get(b);

    if( a == b ) return;
    if( size[a] > size[b] ){
        par[b] = a;
        size[a] += size[b];
    }else{
        par[a] = b;
        size[b] += size[a];
    }
}

int main (){

    std::ios_base::sync_with_stdio(false);
    std::cin.tie(NULL);

    int n, m;
    std::cin>>n>>m;

    for( int i=0 ; i<=n ; i++ ){
        par[i] = i;
        size[i] = 1;
    }

    for( int i=0 ; i<m ; i++ ){
        int a, b, c;
        std::cin>>a>>b>>c;
        e.push_back({c, {a, b}});
    }

    std::sort( e.begin(), e.end() );

    ll nas = 0;
    for( auto j : e ){
        int a = j.second.first;
        int b = j.second.second;
        if( get(a) != get(b) ){
            uni(a, b);
            nas += j.first;
        }
    }

    std::cout<<nas<<"\n";

    return 0;
}
