#include <algorithm>
#include <iostream>
#include <numeric>
#include <cstring>
#include <vector>
#include <bitset>

typedef long long llong;
const short MAXN = 300 + 10;
const short MAXNUM = 10000 + 10;
const short MAXLOG = 15;
const short INF  = 1e9;

int n;
int a[MAXN];
std::bitset <MAXN * MAXNUM> bs;
void solve()
{
    bs[0] = 1;
    int sum = 0;
    for (int i = 1 ; i <= n ; ++i)
    {
        bs |= (bs << a[i]);
        sum += a[i];
    }

    int ans = MAXN * MAXNUM;
    for (int i = 0 ; i < MAXN * MAXNUM ; ++i)
    {
        if (bs[i])
        {
            ans = std::min(ans, abs(sum - 2*i));
        }
    }

    std::cout << ans << '\n';
}

void read()
{
    std::cin >> n;
    for (short i = 1 ; i <= n ; ++i)
    {
        std::cin >> a[i];
    }
}

void fastIO()
{
    std::ios_base :: sync_with_stdio(0);
    std::cout.tie(nullptr);
    std::cin.tie(nullptr);
}

int main()
{
    fastIO();
    read();
    solve();

    return 0;
}
