#include <bits/stdc++.h>
using namespace std;
const int MAX_N = 50000;
const int MAX_M = 100000;
bool inMST[MAX_N];
//vector<pair<int, int> > v[MAX_N];
struct Edge{
    int from;
    int to;
    int len;
};
bool operator <(Edge a, Edge b)
{
    return a.len < b.len;
}
bool cmp(Edge a, Edge b)
{
    return a.len < b.len;
}
vector<Edge> e;
int parent[MAX_N];
int sizes[MAX_N];
int get(int x)
{
    if(x == parent[x])
    {
        return parent[x];
    }
    parent[x] = get(parent[x]);
    return parent[x];
}
void uni(int a, int b)
{
    int parA = get(a);
    int parB = get(b);
    if(sizes[parA] < sizes[parB])
    {
        parent[parA] = parB;
        sizes[parB] += sizes[parA];
    }
    else
    {
        parent[parB] = parA;
        sizes[parA] += sizes[parB];
    }
}
int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    int n, m;
    cin >> n >> m;
    for(int i = 0; i < m; i++)
    {
        int from, to, d;
        cin >> from >> to >> d;
        from--;
        to--;
        e.push_back({from, to, d});
        //v[from].push_back({to, d});
    }
    sort(e.begin(), e.end(), cmp);
    for(int i = 0; i < n; i++)
    {
        parent[i] = i;
        sizes[i] = 1;
    }
    int res = 0;
    for(int i = 0; i < e.size(); i++)
    {
        if(get(e[i].from) == get(e[i].to))
        {
            continue;
        }
        res += e[i].len;
        uni(e[i].from, e[i].to);
    }
    cout << res;
    /*priority_queue<Edge> pq;
    for(int i = 0; i < v[0].size(); i++)
    {
        pq.push({0, v[0][i].first, v[0][i].second});
    }
    inMST[0] = true;
    int res = 0;
    while(!pq.empty())
    {
        Edge e = pq.top();
        pq.pop();
        if(inMST[e.to])
        {
            continue;
        }
        res += e.len;
        inMST[e.to] = true;
        for(int i = 0; i < v[e.to].size(); i++)
        {
            pq.push({e.to, v[e.to][i].first, v[e.to][i].second});
        }
    }
    cout << res;*/
    return 0;
}
