#include <bits/stdc++.h>
using namespace std;
int BIT[500][500];
int m;
void update(int y, int x, int delta) {
    for(; x <= m; x+=x&-x) {
        BIT[y][x] ^= delta;
    }
}

int query(int y, int x) {
    if(x == 0) return 0;
    int result = 0;
    for(; x > 0; x-=x&-x) {
        result ^= BIT[y][x];
    }

    return result;
}
int main() {
    int n;
    cin >> n >> m;
    int arr[n][m];
    for(int i = 0; i < n; i++) {
        for(int j = 0; j < m; j++) {
            cin >> arr[i][j];
            update(j, i + 1, arr[i][j]);
        }
    }

    long long result = 0;
    for(int i = 0; i < n; i++) {
        for(int j = 0; j < m; j++) {

            for(int x = i; x < n; x++) {
                for(int y = j; y < m; y++) {
                    //cout << i << " - " << x << " and " << j << " - " << y << endl;
                    long long curr = 0;
                    for(int row = i; row <= x; row++) {
                        curr ^= query(row, y + 1) ^ query(row, j);
                    }
                    result += curr;
                    //cout << curr << endl;
                }
            }

        }
    }

    cout << result << endl;



    return 0;
}
