#include<iostream>
using namespace std;
struct Path{
    int from;
    int to;
    bool is_diff;
    bool is_highway;
    bool have_passed=false;
};
Path roads[200000];
int CORE=0;
int br=0;

bool can_you_reach_the_core(int d_from,int br_roads,int br_cites){
    if(d_from==CORE){
        return true;
    }
    for(int i=0;i<br_roads;i++){
        if(roads[i].from==d_from){
            if(roads[i].to==CORE && roads[i].is_highway){return true;}
            if(roads[i].is_highway && !roads[i].have_passed){
                return can_you_reach_the_core(roads[i].to,br_roads,br_cites);
            }
        }
    }
    for(int i=0;i<br_roads;i++){
        if(roads[i].from==d_from && can_you_reach_the_core(roads[i].to,br_roads,br_cites) && !roads[i].is_highway){
            roads[i].is_highway=true;
            br++;
            return true;
        }
    }
}

int main(){
    int br_cites,br_roads;

    cin>>br_cites>>br_roads;

    for(int i=0;i<br_roads;i++){
        cin>>roads[i].from>>roads[i].to>>roads[i].is_diff;
        roads[i+br_roads].from=roads[i].to;
        roads[i+br_roads].to=roads[i].from;
        roads[i].is_highway=!roads[i].is_diff;
        roads[i+br_roads].is_highway=roads[i].is_highway;
    }
    for(int i=0;i<br_cites;i++){
        can_you_reach_the_core(i,br_roads,br_cites);
    }
    cout<<br<<endl;
}
