#include<bits/stdc++.h>
using namespace std;

const int maxn=50003;

int n, m;
vector<pair<int, int>> nbrs[maxn];

bool vis[maxn];

void dfs(int x){
    vis[x]=true;

    for(auto [to, dist]: nbrs[x]){
        if(!vis[to] and dist==0){
            dfs(to);
        }
    }
}

int main(){
ios_base::sync_with_stdio(false);
cin.tie(NULL);


cin>>n>>m;
for(int i=0; i<m; i++){
    int a, b, c;
    cin>>a>>b>>c;
    nbrs[a].push_back({b, c});
    nbrs[b].push_back({a, c});
}

int comp=0;

for(int i=1; i<=n; i++){
    if(!vis[i]){
        dfs(i);
        comp++;
    }
}
cout<<comp-1<<endl;
return 0;
}
