#include <iostream>
#include <vector>
#include <map>
using namespace std;

struct Edge
{
    int First;
    int Second;
};

int n, parent[50002],m,count=0;
map<int,vector<Edge>> s;
int findNode(int index)
{
	while(parent[index]!=index)
	{
		index= parent[index];
	}
	return index;
}

int main()
{
	ios::sync_with_stdio(false);
	scanf("%d %d",&n,&m);
	for(int i = 0 ;i<n;i++)
	{
		parent[i]=i;
	}
	
	for(int i =0; i < m;i++)
	{
		int c;
		Edge e ;
		scanf("%d %d %d",&e.First,&e.Second,&c);
		s[c].push_back(e);
	}	
	
	for(Edge edge :s[0])
	{
		int first = findNode(edge.First);
		int second = findNode(edge.Second);
		if(first==second)
		{
			continue;
		}
		parent[first]=second;
	}
	
	for(Edge edge :s[1])
	{
		int first = findNode(edge.First);
		int second = findNode(edge.Second);
		if(first==second)
		{
			continue;
		}
		else
		{
		count++;	
		}
		parent[first]=second;
	}
	printf("%d\n",count);
}
