#include<bits/stdc++.h>
#define endl '\n'
using namespace std;
const int MAXN=5e4+10;
struct edge
{
    int a,b,t;
    edge(){}
    edge(int _a, int _b, int _t)
    {
        a=_a;
        b=_b;
        t=_t;
    }
};
vector<edge> g;
bool cmp(edge a, edge b)
{
    return a.t<b.t;
}
int used[MAXN];
int depth[MAXN];
int par[MAXN];
int root(int a)
{
    while(par[a]!=a)a=par[a];
    return a;
}
void join(int r1, int r2)
{
    par[r2]=r1;
}
int main()
{
    ios::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);

    int n,m;
    cin>>n>>m;
    for(int i=0;i<m;i++)
    {
        int a,b,c;
        cin>>a>>b>>c;
        g.push_back({a,b,c});
    }
    sort(g.begin(),g.end(),cmp);
    int brComp=n;
    for(int i=1;i<=n;i++)
    {
        par[i]=i;
        depth[i]=1;
    }
    int otg=0;
    for(int i=0;i<g.size()&&brComp>1;i++)
    {
        if(used[g[i].a]&&used[g[i].b])continue;
        int r1=root(g[i].a);
        int r2=root(g[i].b);
        if(r1==r2)continue;
        join(r1,r2);
        brComp--;
        used[g[i].a]=1;
        used[g[i].b]=1;
        if(g[i].t==1)otg++;
    }
    cout<<otg<<endl;
}
/**
9 12
1 2 1
2 3 0
4 5 0
5 6 0
4 8 0
8 9 0
1 4 1
4 7 0
2 5 0
5 8 0
3 6 0
6 9 0

*/

