#include <bits/stdc++.h>
#define endl '\n'

using namespace std;

const int MAX_N = 50000;
const int MAX_M = 100000;

vector<pair<int, bool>> nodes[MAX_N];
pair<int, bool> visited[MAX_N];

int result = 0;

void walker(int nodeIndex, int currentGas){
    for( pair<int, bool> nextNode : nodes[nodeIndex] ){
        int temp = nextNode.second ? currentGas + 1 : currentGas;
        //cout << "nextNode: " << nextNode.first <<' ' << nextNode.second << endl;
        //cout << "gas: " << temp << ' ' << currentGas << endl;
        //cout << "DEBUG: " << visited[nextNode.first].first << endl;
        if(temp < visited[nextNode.first].first) {
            if(nextNode.second && temp >= currentGas) result++;
            //cout << "walker: " << nodeIndex << " -> " << nextNode.first << ' ' << temp << endl;
            visited[nextNode.first].first = temp;
            walker(nextNode.first, temp);
        }

    }
}

int main(){
    ios_base::sync_with_stdio(false);
    cin.tie(0); cout.tie(0);
    cout << boolalpha;

    int n = 0,
        m = 0;

    cin >> n >> m;

    for(int i = 0; i < m; i++){
        int v = 0, w = 0, d = 0;
        cin >> v >> w >> d;

        bool isHard = (d != 0);

        nodes[v - 1].push_back(make_pair(w - 1, isHard));
        nodes[w - 1].push_back(make_pair(v - 1, isHard));
    }

    for(size_t i = 0; i < MAX_N; i++) visited[i].first = INT_MAX;
    visited[0].first = 0;


    walker(0, 0);

    cout << result << endl;

    return 0;
}

