#include <iostream>
#include <cstdlib>
#include <cmath>
using namespace std;
long long int binary(int number)
{
    int binN[15], idx = 0;
    long long int bin = 0;
    while(number != 0)
    {
        binN[idx] = number % 2;
        number/=2;
        idx++;
    }
    for(int i = 0; i<idx; i++)
    {
        bin += binN[i] * pow((long double)10,i);
    }
    return bin;
}

int xor_single(int number1, int number2)
{
    int value = 0;
    long long int n1Bin,n2Bin;
    n1Bin = binary(number1);
    n2Bin = binary(number2);
    if(n2Bin>n1Bin)
    {
        swap(n2Bin,n1Bin);
    }
    int missingZeros = 0,t = n1Bin;
    while(t/10>n2Bin/10)
    {
        t/=10;
        missingZeros++;
    }
    int n1Digits[15],n2Digits[15],idx = 0,nLength;
    t = n1Bin;
    while(t!=0)
    {
        n1Digits[idx] = t%10;
        t/=10;
        idx++;
    }
    t = n2Bin;
    nLength = idx;
    idx = 0;
    while(t!=0)
    {
        n2Digits[idx] = t%10;
        t/=10;
        idx++;
    }
    for(int i = idx; i<missingZeros; i++)
    {
        n2Digits[i] = 0;
    }
    int resultDigits[15];
    for(int i = 0; i<nLength; i++)
    {
        if(n1Digits[i] == n2Digits[i]) resultDigits[i] = 0;
        else resultDigits[i] = 1;
    }
    for(int i = 0; i<nLength; i++)
    {
        value += resultDigits[i] * pow(2,i);
    }
    return value;
}


int xor_m(int numbers[])
{
   int value;
   for(int i = 0; i<sizeof(numbers); i++)
   {
        value = xor_single(numbers[i],numbers[i+1]);
        numbers[i+1] = value;
   }
   return value;
}

int main()
{
    unsigned int a[299][299];
    int m,n;
    cin>>m>>n;
    if(m>=300 || m<=1 || n>=300 || n<=1) return 0;
    for(int i = 0; i<m; i++)
    {
        for(int j = 0; j<n; j++)
        {
            cin>>a[i][j];
            if(a[i][j]>=10000) return 0;
        }
    }
    int sum = 0;
    for(int i1 = 0; i1<m; i1++)
    {
        for(int j1 = 0; j1<n; j1++)
        {
            for(int i2 = i1; i2<m; i2++)
            {
                for(int j2 = j1; j2<n; j2++)
                {
                    int subtableSize = (i2-i1)*(j2-j1);
                    int numbersInSubtable[subtableSize];
                    for(int i = i1; i<i2; i++)
                    {
                        for(int j = j1; j<j2 ; j++)
                        {
                            int index = i*(j2-j1) + j;
                            numbersInSubtable[index] = a[i][j];
                        }
                    }
                    sum+=xor_m(numbersInSubtable);
                }
            }
        }
    }
    cout<<sum;
}


