#include<iostream>
#include<bits/stdc++.h>
using namespace std;
vector<int> edges[50010];
bool used[50010];
bool usedALL[50010];
void bfs(int st)
{
    queue<int> q;
    q.push(st);
    memset(used,0,50010);
    used[st]=1;
    usedALL[st]=1;
    while(!q.empty())
    {
        int curr=q.front();
        q.pop();
        for(int i=0;i<edges[curr].size();i++)
        {
            int curr2=edges[curr][i];
            if(used[curr2]==0)
            {
                used[curr2]=1;
                usedALL[curr2]=1;
                q.push(curr2);
            }
        }
    }
}
int main()
{
    int n,m;
    int cnt=-1;
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cin>>n>>m;
    for(int i=0;i<m;i++)
    {
        int a,b;
        bool d;
        cin>>a>>b>>d;
        if(d==0)
        {
            edges[a].push_back(b);
            edges[b].push_back(a);
        }
    }
    for(int i=1;i<=n;i++)
    {
        if(usedALL[i]==0){bfs(i);cnt++;}
    }
    cout<<cnt<<"\n";
}