#include <iostream>
#include <cmath>
#include <climits>

int main(void)
{
    int n;
    std::cin >> n;

    int numbers[n];

    // Get all the user input for the numbers array
    for (int index = 0; index < n; index++)
        std::cin >> numbers[index];

    int minimal_element = INT_MAX;
    int minimal_index = -1;

    int maximal_element = INT_MIN;
    int maximal_index = -1;

    // Find minimal
    for (int index = 0; index < n; index++)
    {
        int current_number = numbers[index];

        if (current_number < minimal_element)
        {
            minimal_element = current_number;
            minimal_index = index;
        } else if (current_number > maximal_element)
        {
            maximal_element = current_number;
            maximal_index = index;
        }
    }

    // Now we have the two indeces
    int first_sequence[n - 2];
    int second_sequence[2];

    second_sequence[0] = numbers[minimal_index];
    second_sequence[1] = numbers[maximal_element];

    int fs_iterator = 0;

    for (int index = 0; index < n; index++)

        if (index != maximal_index && index != minimal_index)
            first_sequence[fs_iterator++] = numbers[index];

    // Now we should have the two sequences

    int fs_sum = 0;
    int ss_sum = second_sequence[0] + second_sequence[1];

    for (int index = 0; index < n - 2; index++)
        fs_sum += first_sequence[index];

    int result = std::abs(fs_sum - ss_sum);

    std::cout << result;

    return 0;
}