#include <iostream>
#include <set>
#include <vector>
#include <cmath>

int main(void)
{
    int n;
    std::cin >> n;
    int sequence[n];

    std::set<int> first_sequence_numbers;
    std::set<int> second_sequence_numbers;
    std::vector<int> first_sequence;
    std::vector<int> second_sequence;


    // Read the user input
    for (int index = 0; index < n; index++)
        std::cin >> sequence[index];

    int next_index = 0;

    for (int iter = 0; iter < n; iter++)
    {
        if (first_sequence_numbers.count(sequence[iter]))
        {
            first_sequence.push_back(sequence[iter]);
            continue;
        } else if (second_sequence_numbers.count(sequence[iter]))
        {
            second_sequence.push_back(sequence[iter]);
            continue;
        } else {
            if (next_index / 2 == 0) {
                first_sequence.push_back(sequence[iter]);
                first_sequence_numbers.insert(sequence[iter]);
            } else {
                second_sequence.push_back(sequence[iter]);
                second_sequence_numbers.insert(sequence[iter]);
            }
            next_index++;
        }   
    }

    int fs_sum = 0;
    int ss_sum = 0;

    // Find First sum
    for (int iter = 0; iter < first_sequence.size(); iter++)
        fs_sum += first_sequence[iter];

    // Find Second sum
    for (int iter = 0; iter < second_sequence.size(); iter++)
        ss_sum += second_sequence[iter];

    int result = std::abs(fs_sum - ss_sum);

    std::cout << result;

    return 0;
}