#include <bits/stdc++.h>

using namespace std;

struct Road {
    int connected_with;
    int connected_from;
    bool easy;
};

struct City {
    int id;
    vector<Road> roads;
    bool visited;
};
int bfs(City start, int index, City cities[]) {
    int c = 1;
    cities[index].visited = true;
    for ( int i = 0; i < start.roads.size(); i ++ ) {

        if ( !start.roads[i].easy && !cities[start.roads[i].connected_with].visited ) {
                //cout << start.roads[i].easy << "r: " << start.roads[i].connected_from << " - " << start.roads[i].connected_with << endl;
                c += bfs(cities[start.roads[i].connected_with], start.roads[i].connected_with, cities);
        }
    }

    return c;
}

int go_through(City cities[], int i, int n) {
    cities[i].id = i;
    int c = bfs(cities[i], i, cities), r = 0;
    if ( c < n ) {
        for ( int j = 0; j < cities[i].roads.size(); j ++ ) {
            if ( cities[i].roads[j].easy ) {
                cities[i].roads[j].easy = 0;
                for ( int m = 0; m < cities[cities[i].roads[j].connected_with].roads.size(); m ++ )
                {if (cities[cities[i].roads[j].connected_with].roads[m].connected_with == i ) cities[cities[i].roads[j].connected_with].roads[m].easy = 0;}
                c = bfs(cities[i], i, cities);
                r ++;
                if ( c == n ) break;
            }
        }
    }
    return r;
}

int main () {
    int n, m;
    cin >> n >> m;
    City cities[n + 1];
    Road roads[m];
    for ( int i = 0; i < m; i ++ ) {
        cin >> roads[i].connected_from >> roads[i].connected_with >> roads[i].easy;
        cities[roads[i].connected_from].roads.push_back(roads[i]);
        Road r2;
        r2.connected_from = roads[i].connected_with;
        r2.connected_with = roads[i].connected_from;
        r2.easy = roads[i].easy;
        cities[roads[i].connected_with].roads.push_back(r2);
    }
    int res = 0;
    for ( int i = 1; i < n; i ++ ) {
            res += go_through(cities, i, n);
    }
    cout << res << endl;
    return 0;
}
