#include<bits/stdc++.h>
using namespace std;

bool used[1024];
vector<int> edges[1024], edges2[1024];
int curCities = 0;

void resetUsed(int n) {
    for(int i = 1; i <= n; i++) {
        used[i] = false;
    }
}

void dfs(int k) {
    if(used[k]) return;
    used[k] = true;
    curCities++;

    for(auto edge : edges[k]) {
        dfs(edge);
    }
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    int n, m;
    cin>>n>>m;
    for(int i = 0; i < m; i++) {
        int a, b, c;
        cin>>a>>b>>c;
        if(c == 0) {
            edges[a].push_back(b);
            edges[b].push_back(a);
        } else {
            edges2[a].push_back(b);
            edges2[b].push_back(a);
        }
    }

    dfs(1);
    resetUsed(n);

    int ans = 0;
    while(curCities < n){
        for(auto edge : edges2[i]) {
            edges[i].push_back(edge);
            edges[edge].push_back(i);
            ans++;
            dfs(1);
            resetUsed();
            if(curCities == n) break;
        }
    }

    cout<<1<<endl;



    return 0;
}
