#include <algorithm>
#include <iostream>
#include <numeric>
#include <cstring>
#include <vector>

typedef long long llong;
const short MAXN = 300 + 10;
const short MAXLOG = 15;
const short INF  = 1e9;

short n, m;
short cnt[MAXLOG][2];
short a[MAXN][MAXN];
short p[MAXN][MAXN];
std::vector <short> v[MAXN][MAXN];

void solve()
{
    for (short i = 1 ; i <= n ; ++i)
    {
        for (short j = 1 ; j <= m ; ++j)
        {
            p[i][j] = p[i-1][j] ^ p[i][j-1] ^ p[i-1][j-1] ^ a[i][j];
        }
    }

    for (short row = 0 ; row <= n ; ++row)
    {
        for (short col2 = 1 ; col2 <= m ; ++col2)
        {
            for (short col1 = 0 ; col1 < col2 ; ++col1)
            {
                v[col1][col2].push_back(p[row][col1] ^ p[row][col2]);
            }
        }
    }

    return;
    llong ans = 0;
    for (short i = 1 ; i <= m ; ++i)
    {
        for (short j = 0 ; j < i ; ++j)
        {
            memset(cnt, 0, sizeof(cnt));
            for (const short &curr : v[j][i])
            {
                for (short k = 0 ; k < MAXLOG ; ++k)
                {
                    ans += cnt[k][1 ^ ((curr >> k) & 1)] * (1LL << k);
                    cnt[k][(curr >> k) & 1]++;
                }
            }
        }
    }

    std::cout << ans << '\n';
}

void read()
{
    std::cin >> n >> m;
    for (short i = 1 ; i <= n ; ++i)
    {
        for (short j = 1 ; j <= m ; ++j)
        {
            std::cin >> a[i][j];
        }
    }
}

void fastIO()
{
    std::ios_base :: sync_with_stdio(0);
    std::cout.tie(nullptr);
    std::cin.tie(nullptr);
}

int main()
{
    fastIO();
    read();
    solve();

    return 0;
}
