#include <algorithm>
#include <iostream>
#include <numeric>
#include <cstring>
#include <cassert>
#include <vector>

typedef long long llong;
const short MAXN = 300;
const short MAXLOG = 14;
const short INF  = 1e9;

short n, m;
short cnt[2];
short a[MAXN][MAXN];
short p[MAXN][MAXN];

void solve()
{
    llong ans = 0;
    for (int k = 0 ; k < MAXLOG ; ++k)
    {
        for (short i = 1 ; i <= n ; ++i)
        {
            for (short j = 1 ; j <= m ; ++j)
            {
                p[j][i] = p[j][i-1] ^ p[j-1][i] ^ p[j-1][i-1] ^ ((a[i][j] >> k) & 1);
            }
        }

        for (short col1 = 0 ; col1 < m ; ++col1)
        {
            for (short col2 = col1 + 1 ; col2 <= m ; ++col2)
            {
                cnt[0] = cnt[1] = 0;
                for (short row = 0 ; row <= n ; ++row)
                {
                    ans += cnt[1 ^ p[col1][row] ^ p[col2][row]] * (1LL << k);
                    cnt[p[col1][row] ^ p[col2][row]]++;
                }
            }
        }
    }

    std::cout << ans << '\n';
}

void read()
{
    std::cin >> n >> m;
    for (short i = 1 ; i <= n ; ++i)
    {
        for (short j = 1 ; j <= m ; ++j)
        {
            std::cin >> a[i][j];
        }
    }
}

void fastIO()
{
    std::ios_base :: sync_with_stdio(0);
    std::cout.tie(nullptr);
    std::cin.tie(nullptr);
}

int main()
{
    fastIO();
    read();
    solve();

    return 0;
}
