#include<bits/stdc++.h>
using namespace std;
#define INF 1000000

vector<pair<int,int>> edges[50001];
int res[20001][20001];

void floyd(int n){
    for(int i=1;i<=n;i++){
        for(int j=1;j<=n;j++){
            res[i][j]=INF;
        }
    }
    for(int i=1;i<=n;i++){
        res[i][i]=0;
        for(int j=0;j<edges[i].size();j++){
            res[i][edges[i][j].first]=edges[i][j].second;
        }
    }
    for(int k=1;k<=n;k++){
        for(int i=1;i<=n;i++){
            for(int j=1;j<=n;j++){
                if(res[i][k]+res[k][j]<res[i][j]){
                    res[i][j]=res[i][k]+res[k][j];
                }
            }
        }
    }
}

int main(){
    int n,m;
    cin>>n>>m;
    for(int i=0;i<m;i++){
        int a,b,w;
        cin>>a>>b>>w;
        edges[a].push_back({b,w});
        edges[b].push_back({a,w});
    }
    floyd(n);
    int maxn=-INF;
    for(int i=1;i<=n;i++){
        for(int j=1;j<=n;j++){
            if(res[i][j]>maxn) maxn=res[i][j];
        }
    }
    cout<<maxn<<endl;
    return 0;
}
