#include <iostream>
using namespace std;
int table[302][302];
int prefix_rows[302][302];
int prefix_rect[302][302];
int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    int n, m;
    cin >> m >> n;
    for (int y = 1; y <= m; y++) {
        for (int x = 1; x <= n; x++) {
            cin >> table[x][y];
            prefix_rows[x][y] = 0;
            prefix_rect[x][y] = 0;
        }
    }
    for (int x = 0; x < n; x++) {
        prefix_rows[x][0] = 0;
        table[x][0] = 0;
        prefix_rect[x][0] = 0;
        prefix_rows[x][m + 1] = 0;
        table[x][m + 1] = 0;
        prefix_rect[x][m + 1] = 0;
    }
    for (int y = 0; y < m; y++) {
        prefix_rows[0][y] = 0;
        table[0][y] = 0;
        prefix_rect[0][y] = 0;
        prefix_rows[n + 1][y] = 0;
        table[n + 1][y] = 0;
        prefix_rect[n + 1][y] = 0;
    }
    prefix_rows[1][1] = table[1][1];
    for (int y = 1; y <= m; y++) {
        if (y > 1) {
            prefix_rows[1][y] = prefix_rows[n][y - 1] ^ table[1][y];
        }
        for (int x = 2; x <= n; x++) {
            prefix_rows[x][y] = prefix_rows[x - 1][y] ^ table[x][y];
        }
    }
    prefix_rect[1][1] = table[1][1];
    for (int y = 1; y <= m; y++) {
        for (int x = 1; x <= n; x++) {
            prefix_rect[x][y] = prefix_rect[x][y - 1] ^ (prefix_rows[x][y] ^ prefix_rows[n][y - 1]);
        }
    }
    long long ans = 0;
//        for (int a = 1; a <= m; a++) {
//            for (int b = a; b <= m; b++) {
//                for (int c = 1; c <= n; c++) {
//                    for (int d = c; d <= n; d++) {
//                        ans += prefix_rect[d][b] ^ prefix_rect[c - 1][b] ^ prefix_rect[d][a - 1] ^ prefix_rect[c - 1][a - 1];
//                    }
//                }
//            }
//        }
        for (long long co = 0; co < m * m * n * n; co++) {
            long long curr = co;
            long long y1 = (curr / (m * n * n)) + 1;
            curr %= (m * n * n);
            long long y2 = (curr / (n * n)) + 1;
            curr %= (n * n);
            long long x1 = (curr / n) + 1;
            curr %= n;
            long long x2 = (curr) + 1;
            if (x1 <= x2 && y1 <= y2) {
                ans += prefix_rect[x2][y2] ^ prefix_rect[x1 - 1][y2] ^ prefix_rect[x2][y1 - 1] ^ prefix_rect[x1 - 1][y1 - 1];
            }
        }
    cout << ans;
    return 0;
}


