//#include <bits/stdc++.h>
#include <iostream>
#include <vector>
using namespace std;
const int MAXN = 50001;
vector<int> neighbours[MAXN];
bool visited[MAXN];
void bfs(int curr) {
    if (visited[curr]) {
        return;
    }
    visited[curr] = true;
    for (auto it : neighbours[curr]) {
        bfs(it);
    }
}
int main() {
//    ios_base::sync_with_stdio(false);
//    cin.tie(0);
//    cout.tie(0);
    int n, m;
    cin >> n >> m;
    for (int i = 1; i <= n; i++) {
        visited[i] = false;
    }
    for (int i = 0; i < m; i++) {
        int a, b, c;
        cin >> a >> b >> c;
        if (c == 0) {
            neighbours[a].push_back(b);
            neighbours[b].push_back(a);
        }
    }
    int ans = 0;
    for (int i = 1; i <= n; i++) {
        if (!visited[i]) {
            ans++;
            bfs(i);
        }
    }
    cout << ans - 1;
    return 0;
}
