#include<bits/stdc++.h>
#define endl '\n'
using namespace std;

struct Edge
{
    int u,v,w;
};

const int MAXN=5e4+5;
const int MAXM=1e5+5;

int n,m;
Edge edge[MAXM];
int par[MAXN];
int depth[MAXN];
int brComp;

int getRoot(int v)
{
    while(v!=par[v]) v=par[v];
    return v;
}

void join(int r1,int r2)
{
    if(depth[r1]<depth[r2]) par[r1]=r2;
    else if(depth[r1]>depth[r2]) par[r2]=r1;
    else
    {
        par[r1]=r2;
        depth[r2]++;
    }
}

bool cmp(Edge a,Edge b)
{
    return a.w<b.w;
}

int main()
{
ios::sync_with_stdio(0);
cin.tie(0);
cout.tie(0);

cin>>n>>m;
for(int i=0;i<m;i++)
{
    cin>>edge[i].u>>edge[i].v>>edge[i].w;
}

sort(edge,edge+m,cmp);
for(int i=1;i<=n;i++)
{
    par[i]=i;
    depth[i]=1;
}
brComp=n;

int ans=0;
for(int i=0;i<m;i++)
{
    int r1=getRoot(edge[i].u);
    int r2=getRoot(edge[i].v);
    if(r1!=r2)
    {
        join(r1,r2);
        brComp--;
        ans+=edge[i].w;
        if(brComp==1) break;
    }
}

cout<<ans<<endl;
return 0;
}
