#include <bits/stdc++.h>
#define endl '\n'

using namespace std;

const int MAX_N = 500;
const int MAX_M = 600;

vector<pair<int, bool>> nodes[MAX_N];
int visited[MAX_N];

int result = 0;

void walker(int nodeIndex, int currentGas){
    for( pair<int, bool> nextNode : nodes[nodeIndex] ){
        int temp = nextNode.second ? currentGas + 1 : currentGas;
        if(temp < visited[nextNode.first]) {
            //cout << "walker: " << nodeIndex << " -> " << nextNode.first << ' ' << temp << endl;
            visited[nextNode.first] = temp;
            walker(nextNode.first, temp);
        }
    }
}

int main(){
    ios_base::sync_with_stdio(false);
    cin.tie(0); cout.tie(0);

    int n = 0,
        m = 0;

    cin >> n >> m;

    for(int i = 0; i < m; i++){
        int v = 0, w = 0, d = 0;
        cin >> v >> w >> d;

        bool isHard = (d != 0);

        nodes[v - 1].push_back(make_pair(w - 1, isHard));
        nodes[w - 1].push_back(make_pair(v - 1, isHard));
    }

    for(size_t i = 0; i < n; i++) visited[i] = INT_MAX;
    visited[0] = 0;

    walker(0, 0);

    for(size_t i = 1; i < n; i++)
        if(visited[i - 1] < visited[i]) result++;
    //cout << endl;

    cout << result << endl;
    return 0;
}